// ------------------------------------------------------------------------------
//  <autogenerated>
//      This code was generated by a tool.
//      Mono Runtime Version: 4.0.30319.1
// 
//      Changes to this file may cause incorrect behavior and will be lost if 
//      the code is regenerated.
//  </autogenerated>
// ------------------------------------------------------------------------------
using System;
using System.Net;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace CCP_Connection_Example
{
	public class ConnectionHandler
	{
		Socket socket;
		public int wantedPort;
		public bool connectedToCCP;
		public string masterChannelIdentifier = "App identifier"; // has to match "Master Channel identifier" in your layout on CCP application.

		private byte[] bytes;
		public CPadChannelEvent cPadMessage; // this is the class containing the structure of a "Channel" message for CCP.

		public ConnectionHandler ()
		{
		}


		public uint tstValue;
		public uint actualGaugeValue =  (uint) 0;
		public uint gaugeMax =(uint) 1000;
		public uint gaugeMin =(uint) 0;
		public string gaugeDescription = "Analog gauge test";

		public void LoopExample() {
			if (!connectedToCCP && wantedPort != 0)
				Connect();

			if (connectedToCCP) {
				// will now send a string on Channel 1;
				CommunicateString("test string", (uint) 1);

				// will communicate and increasing value on channel 2
				tstValue++;
				CommunicateValue(tstValue, (uint) 2);

				// will now send data to analog gauge on channel 3
				actualGaugeValue++;
				if (actualGaugeValue >= gaugeMax)
					actualGaugeValue = gaugeMin;

				CommunicateRangedValue(actualGaugeValue ,ugaugeMin,gaugeMax,gaugeDescription, (uint) 3);


			}
		}


		bool connecting;
		public void Connect() {
			if (connecting)
				return;
			connecting = true;
			wantedPort = 42010; // set this to the port shown by CCP server application.
			cPadMessage = new CPadChannelEvent();
			cPadMessage.masterChannelIdentifier = masterChannelIdentifier;

			Socket socket = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);    
			IPAddress ip = IPAddress.Parse("127.0.0.1"); // local "home" ip adress, should always be the same.
			IPEndPoint ep = new IPEndPoint(ip,wantedPort);
			try {
				socket.Connect( ep);
			}
			catch (Exception e) {
				
			}    
			if (socket.Connected) {
				//suck.Send(bytes,bytes.length, 0 );    
				connectedToCCP = true;
				status = "Connected";
				
				
			}
			else {
				connectedToCCP = false;
				
			} 
			connecting = false;
		}
		
		public void CommunicateString(string stringToSend, uint channelId) {
			if (socket == null || cPadMessage == null)
				return;
			cPadMessage.channelIdentifier = channelId;

			cPadMessage.inputLabel = stringToSend;
			bytes = cPadMessage.ToBytes();
			socket.Send(bytes,bytes.Length, 0 );
		}

		public void CommunicateValue(uint intToSend, uint channelId) {
			// will simply send a UINT value to CCP
			if (socket == null || cPadMessage == null)
				return;
			cPadMessage.channelIdentifier = channelId;
			cPadMessage.inputValue = (uint) intToSend;
			bytes = cPadMessage.ToBytes();
			socket.Send(bytes,bytes.Length, 0 );
		}

		public void CommunicateRangedValue(uint actualValue,uint minValue,uint maxValue,string description, uint channelId) {
			if (socket == null || cPadMessage == null)
				return;
			cPadMessage.channelIdentifier = channelId;

			cPadMessage.inputValue = (uint) actualValue;
			cPadMessage.inputMin = (uint) minValue;
			cPadMessage.inputMax = (uint) maxValue;
			cPadMessage.inputLabel = description;

			bytes = cPadMessage.ToBytes();
			socket.Send(bytes,bytes.Length, 0 );
		}



	}
}

